#include "StdAfx.h"
#include "Delay.h"
#include "math.h"
#include "OpenALTestDlg.h"

Delay::Delay(int maxBuffer)
: Filter(maxBuffer)
{
	ringPointer = 0;
	for (int i = 0; i < BUF_SIZE; i++)
	{
		ringBuffer[i] = 0;
	}
}

Delay::~Delay(void)
{
}

void Delay::Process(short* dataIn, short* dataOut, int length, COpenALTestDlg* parent)
{
	WaitForSingleObject(parent->sliderMutex, INFINITE);
	double c1 = parent->slider1; // wet <-> dry
	double c2 = parent->slider2; // feedback
	ReleaseMutex(parent->sliderMutex);

	for(int i = 0; i < length; i++)
	{
		short delayedSample = ringBuffer[ringPointer];
		ringBuffer[ringPointer] = dataIn[i] + (short)(c2*delayedSample);
		dataOut[i] = (short)((1.0-c1)*dataIn[i] + c1*delayedSample);
		ringPointer++;
		if(ringPointer >= BUF_SIZE)
		{
			ringPointer = 0;
		}
	}
}
