#include "StdAfx.h"
#include "Downsampler.h"
#include "OpenALTestDlg.h"

Downsampler::Downsampler(int maxBuffer)
: Filter(maxBuffer)
{
	for(int h = 0; h < NUM_HISTORY; h++)
	{
		history[h] = 0;
	}
	historyCounter = 0;
	downsampleCounter = 0;
	output = 0;
}

Downsampler::~Downsampler(void)
{
}

void Downsampler::Process(short* dataIn, short* dataOut, int length, COpenALTestDlg* parent)
{
	WaitForSingleObject(parent->sliderMutex, INFINITE);
	double d = parent->slider1;
	ReleaseMutex(parent->sliderMutex);
	int downsampleFactor = 1 + (int)((NUM_HISTORY-0.01)*d);

	for(int i = 0; i < length; i++)
	{
		history[historyCounter] = dataIn[i];

		downsampleCounter++;
		if(downsampleCounter >= downsampleFactor)
		{
			downsampleCounter = 0;
#if 1 //Average on or off, for some (audibly useless) filtering
			int sum = 0;
			for(int h = 0; h < downsampleFactor; h++)
			{
				sum += history[(historyCounter-h+NUM_HISTORY)%NUM_HISTORY];
			}
			output = (short)((sum+0.5)/downsampleFactor);
#else
			output = dataIn[i];
#endif
		}
		dataOut[i] = output;

		historyCounter++;
		if(historyCounter >= NUM_HISTORY)
		{
			historyCounter = 0;
		}
	}
}
